﻿using Bizgaze.CRM;
using Bizgaze.CRM.Visitors.Infos;
using Bizgaze.CRM.Visitors.Managers;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;
using Unibase.Data;
using Unibase.Data.Expressions;
using Unibase.Data.Sql;
using Unibase.Dependency;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;

namespace Bizgaze.CRM.Visitors.ActionProviders
{
    public class UpdateVisitorBeenHerePreAction : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.UpdateVisitorBeenHerePreAction";

            }
        }
        public string FormActionName
        {
            get
            {
                return "UpdateVisitorBeenHere";
            }
        }
        public string Description
        {
            get
            {
                return "Update Visitor Been Here PreAction";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.UpdateVisitorBeenHere;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PreAction;
            }
        }
        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest request, FormActionProviderObject providerObject)
        {
            var IdValue = providerObject.IdValue;
            var srequest = SelectRequest.FromRequest(request);
            var obj = providerObject.RequestObject;
            var returnresponse = new FormActionResponse();
            var defaultPKValue = providerObject.DefaultPKValue;
            var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
            var visitorManager = Unibase.Dependency.DependencyConfig.Resolve<Bizgaze.CRM.Visitors.Managers.IVisitorManager>();
            var dictObj = obj as IDictionary<string, dynamic>;
            var MobileNumber = dictObj["mobilenumber"].ToString();
            var employeeId = Convert.ChangeType(dictObj["employeeid"].ToString(), typeof(long));
            var cityId = Convert.ChangeType(dictObj["cityid"].ToString(), typeof(long));
            var purposeofvisit = Convert.ChangeType(dictObj["purposeofvisit"].ToString(), typeof(long));
            long visitorid = 0;
            var visitorsinfo = await visitorManager.VisitorsbyMobileNumberAsync(srequest, MobileNumber);
            Int32 refstatusid = 0;
            var stageStatusName = "";
            if (visitorsinfo.Result != null)
            {
                refstatusid = visitorsinfo.Result.RefStatusId;
                visitorid = visitorsinfo.Result.VisitorId;
                if (refstatusid == 1)
                {
                    stageStatusName = "Pre-Invite";
                    var agree = await visitorManager.VisitorAgreementAsync(request, visitorid);
                }
                else
                {
                    stageStatusName = "CheckIn";
                }
                var code = visitorsinfo.Result.Code;

                var agreement = visitorsinfo.Result.Agreement;
                visitorsinfo.Result.Agreement = agreement;
                dictObj["agreement"] = true;
                dictObj["visitorid"] = visitorid;
                dictObj["visitoremailid"] = visitorsinfo.Result.VisitorEmailId;
                dictObj["visitornumberid"] = visitorsinfo.Result.VisitorNumberId;
                var fullname = visitorsinfo.Result.FullName;
                var sql = "select userid from unibasecmn_users where username='" + fullname + "";
                var select = new Unibase.Data.Sql.Select("unibasecmn_users").AllColumns().Where("username", fullname);
                var parameters = new List<Unibase.Data.Parameter>();
                parameters.Add(new Unibase.Data.Parameter("@username", fullname));
                var dt = await GetDataTableAsync(srequest, select, parameters);
                var contactid = dt.Rows[0]["userid"];
                var vistoroptions = new EntityOptions()
                {
                    IsIdentity = true,
                    IsNewEntity = true,
                    TableName = "bizgazecrm_visitors",
                    PkColumn = "visitorid",
                    IsExcludeFromAudit = false,
                    Id = 0,
                };

                dynamic visitor = new Dictionary<string, object>();
                visitor.Add("createdby", srequest.Identity.UserId);
                visitor.Add("createddate", DateTime.Now);
                visitor.Add("statusid", visitorsinfo.Result.StatusId);
                visitor.Add("alternatenumber", visitorsinfo.Result.AlternateNumber);
                visitor.Add("organizationname", visitorsinfo.Result.OrganizationName);
                visitor.Add("checkindate", DateTime.Now);
                visitor.Add("contactid", contactid);
                visitor.Add("code", visitorsinfo.Result.Code);
                visitor.Add("agreement", true);
                visitor.Add("employeeid", employeeId);
                visitor.Add("seriesid", visitorsinfo.Result.SeriesId);
                visitor.Add("stageid", visitorsinfo.Result.StageId);
                visitor.Add("tenantid", visitorsinfo.Result.TenantId);
                visitor.Add("installedappid", visitorsinfo.Result.Installedappid);
                visitor.Add("fullname", visitorsinfo.Result.FullName);
                visitor.Add("futureinvitation", visitorsinfo.Result.FutureInvitation);
                visitor.Add("cityid", cityId);
                visitor.Add("purposeofvisit", visitorsinfo.Result.PurposeOfVisit);
                visitor.Add("title", visitorsinfo.Result.Title);
                visitor.Add("visitortype", visitorsinfo.Result.VisitorType);
                var response = await _repository.SaveAsync(request, vistoroptions, visitor);

                if (response.Status == ResponseStatus.Error)
                {
                    return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "Visitor Check Out Data Not Saved");
                }

                var _visitorId = Convert.ToInt64(response.Result["_Id"].ToString());
                var vistoroptions1 = new EntityOptions()
                {
                    IsIdentity = true,
                    IsNewEntity = true,
                    TableName = "bizgazecrm_visitorcheckout",
                    PkColumn = "visitorcheckoutid",
                    IsExcludeFromAudit = false,
                    Id = 0,
                };
                dynamic visitor1 = new Dictionary<string, object>();
                visitor1.Add("createdby", srequest.Identity.UserId);
                visitor1.Add("visitorid", _visitorId);
                visitor1.Add("checkindate", DateTime.Now);
                visitor1.Add("tenantid", visitorsinfo.Result.TenantId);
                visitor1.Add("comments", "");
                visitor1.Add("checkoutdate", DateTime.MinValue);
                visitor1.Add("rating", 0);
                visitor1.Add("versionguid", Guid.NewGuid());
                visitor1.Add("uniqueid", visitorsinfo.Result.Code);
                visitor1.Add("statusid", (int)RowStatus.Active);
                visitor1.Add("installedappid", visitorsinfo.Result.Installedappid);
                visitor1.Add("lastupdateddate", DateTime.Now);
                var response1 = await _repository.SaveAsync(request, vistoroptions1, visitor1);
                if (response1.Status == ResponseStatus.Error)
                {

                    return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "Visitor Check Out Data Not Saved");
                }
                var lastdate = visitorsinfo.Result.LastUpdatedDate;
                visitorsinfo.Result.LastUpdatedDate = DateTime.Now;
                var installedAppId = visitorsinfo.Result.Installedappid;
                var stage = await stageManager.GetStageByStageStatusAsync(srequest, installedAppId, stageStatusName);
                var NewStageId = stage.Result.StageId;
                DateTime date = DateTime.UtcNow;
                var UpdateStage = new Update("bizgazecrm_visitors").Value("employeeid", visitorsinfo.Result.EmployeeId).Value("stageid", NewStageId).Value("lastupdateddate", date).Where(Exp.Eq("code", code));
                await _repository.ExecuteAsync(request, UpdateStage);
                //var updateDate = new Dictionary<string, object>();
                //updateDate.Add("employeeid", employeeId);
                //updateDate.Add("photourl", image);
                //updateDate.Add("cityid", cityId);
                //updateDate.Add("typeofvisitor", 1);
                //updateDate.Add("stageid", NewStageId);
                //updateDate.Add("agreement", agreement);
                //updateDate.Add("lastupdateddate", date);
                //updateDate.Add("purposeofvisit", purposeofvisit);
                //var updateQry = new Update("bizgazecrm_visitors").Values(updateDate).Where(Exp.Eq("visitorid", visitorid));
                //var ds = await _repository.ExecuteAsync(request, updateQry);
            }
            else
            {
                return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "visitor  Not Found");
            }
            returnresponse = new FormActionResponse();
            returnresponse.Obj = dictObj as ExpandoObject;
            returnresponse.PkValue = defaultPKValue;
            return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);


            //  returnresponse.PkValue = defaultPKValue;
            // return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
        }
        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.UpdateVisitorBeenHere,
            };
            }
        }

    }
}
